# AMPL implementation of IBA exercise 6.21 on machine scheduling 

set jobs;
param duration {jobs};
param release_date {jobs};
param due_date {jobs};
param M;

var start_date {i in jobs} >= release_date[i];
var order {jobs,jobs} binary;
var tardiness {jobs} >=0;

minimize total_tardiness:
  sum {i in jobs} tardiness[i];

subject to tardiness_def {i in jobs}:
  tardiness[i] >= start_date[i] + duration[i] - due_date[i];

subject to order_constraint {i in jobs, j in jobs: i<>j}:
  order[i,j] + order[j,i] = 1;

subject to overlap_constraint {i in jobs, j in jobs: i<>j}:
  start_date[i] + duration[i] <= start_date[j] + M * order[j,i];
